#!/usr/bin/env node

const uglify = require('uglify-numbers');
const prog = require('caporal');

const safeInt = Number.MAX_SAFE_INTEGER || Math.pow(2, 53) - 1;
const safeIntLink =
    'https://developer.mozilla.org/en/docs/Web/JavaScript/Reference/Global_Objects/Number/MAX_SAFE_INTEGER';

prog.version('0.0.1')
    .argument('<number>', 'the number to uglify', prog.FLOAT)
    .description('uglifies numbers using [ ] ( ) + - ! and /"')
    .option('-o, --only-value', 'hide the variable declaration and only return the value')
    .action(function(args, options) {
        const number = args.number;

        const expression = uglify.uglifyNumber(number);
        const evaluated = eval(expression);
        const warning =
            number > safeInt || number < -safeInt
                ? `\n// possible precision loss see\n// ${safeIntLink}`
                : '';
        console.log(
            options.onlyValue
                ? expression
                : `const myNumber = ${expression};\n\nconsole.log(myNumber); // ${evaluated}${warning}`
        );
    });

prog.parse(process.argv);
